<?php

function session_invalidate($dest='')
{
  global $cfg;
  global $_SESSION;

  db_query(sprintf('DELETE FROM online WHERE uid = %d', $_SESSION['uid']));

  setcookie($cfg['session'], '', time()-42000, '/');
  session_destroy();
  $_SESSION = array();

  header("Location: " . $cfg['home'] . $dest);

  exit;
}

function userstatus_info()
{
  global $cfg;

  $ret = array();

  $query = 'SELECT count(*) FROM online';
  $sth = db_query($query);
  if ($sth === false) {
    $ret[0] = 0;
  } else {
    $row = pg_fetch_array($sth, 0);
    $ret[0] = $row[0];
  }

  $query = 'SELECT count(*) FROM users';
  $sth = db_query($query);
  if ($sth === false) {
    $ret[1] = 0;
  } else {
    $row = pg_fetch_array($sth, 0);
    $ret[1] = $row[0];
  }

  $query = 'SELECT count(*) FROM zeitungen WHERE deleted IS false';
  $sth = db_query($query);
  if ($sth === false) {
    $ret[2] = 0;
  } else {
    $row = pg_fetch_array($sth, 0);
    $ret[2] = $row[0];
  }

  $query = 'SELECT count(*) FROM zeitung_tags';
  $sth = db_query($query);
  if ($sth === false) {
    $ret[3] = 0;
  } else {
    $row = pg_fetch_array($sth, 0);
    $ret[3] = $row[0];
  }

  $query = 'SELECT count(*) FROM tags';
  $sth = db_query($query);
  if ($sth === false) {
    $ret[4] = 0;
  } else {
    $row = pg_fetch_array($sth, 0);
    $ret[4] = $row[0];
  }

  return $ret;
}

function session_update()
{
  global $cfg;
  global $_SESSION;

  $info = userstatus_info();

  $_SESSION['online'] = $info[0];
  $_SESSION['users'] = $info[1];
  $_SESSION['zeitungen'] = $info[2];
  $_SESSION['ztags'] = $info[3];
  $_SESSION['tags'] = $info[4];
}

function session_init()
{
  global $cfg;
  global $_COOKIE;
  global $_SERVER;
  global $_SESSION;

  if (isset($_COOKIE[$cfg['session']])) {
    session_name($cfg["session"]);
    session_start();

    if ($_SESSION["REMOTE_ADDR"] != $_SERVER["REMOTE_ADDR"] ||
        !isset($_SESSION["uid"]))
      session_invalidate('login.html?from=session');

    $query = sprintf('UPDATE online SET activity = now() WHERE uid = %d', $_SESSION['uid']);
    db_query($query);

    if ($_SESSION["lastupdate"] < time() - 60) {
      session_update();
      $_SESSION["lastupdate"] = time();
    }
  }
}

?>